## fontforge 20220308~dfsg

=== CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

cmake_minimum_required(VERSION 3.5)

# Update the version for each new release
project(fontforge VERSION 20220308 LANGUAGES C CXX)

# No in source builds
if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In-source builds are disallowed. Create a build folder to run CMake from.")
endif()

# Add folder for custom cmake modules
list(INSERT CMAKE_MODULE_PATH 0 ${PROJECT_SOURCE_DIR}/cmake ${PROJECT_SOURCE_DIR}/cmake/packages)
if(${CMAKE_VERSION} VERSION_LESS "3.15.7")
  # This could be more targeted, but keep it simple
  list(APPEND CMAKE_MODULE_PATH ${PROJECT_SOURCE_DIR}/cmake/backports/3.15.7)
endif()

# Include any required modules
include(BuildUtils)
include(CheckIncludeFile)
include(CPackSetup)
include(CTest)
include(GNUInstallDirs)
include(PackageUtils)
include(TargetUtils)

# Set any global defines
set(CMAKE_C_STANDARD 99)
set(CMAKE_C_STANDARD_REQUIRED TRUE)
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED TRUE)
set(CMAKE_THREAD_PREFER_PTHREAD 1)

set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/bin)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/lib)

set_default_build_type(RelWithDebInfo) # Sets CMAKE_BUILD_TYPE
set_default_rpath()
add_uninstall_target()

# Options
build_option(BUILD_SHARED_LIBS       BOOL ON  "Build libfontforge as a shared library")
build_option(ENABLE_GUI              BOOL ON  "Build FontForge with GUI support")
build_option(ENABLE_X11              BOOL OFF "Build the GUI using the X backend INSTEAD of the GDK backend" "ENABLE_GUI")

build_option(ENABLE_NATIVE_SCRIPTING BOOL ON  "Enables FontForge's native scripting support")
build_option(ENABLE_PYTHON_SCRIPTING BOOL ON  "Enables FontForge's Python scripting support")
build_option(ENABLE_PYTHON_EXTENSION AUTO ON  "Builds the Python models for use with system python")

build_option(ENABLE_LIBSPIRO         BOOL ON  "Enables libspiro support")
build_option(ENABLE_LIBGIF           AUTO ON  "Enables GIF support")
build_option(ENABLE_LIBJPEG          AUTO ON  "Enables JPEG support")
build_option(ENABLE_LIBPNG           AUTO ON  "Enables PNG support")
build_option(ENABLE_LIBREADLINE      AUTO ON  "Enables Readline support")
build_option(ENABLE_LIBTIFF          AUTO ON  "Enables TIFF support")
build_option(ENABLE_WOFF2            AUTO ON  "Enables WOFF2 support")

build_option(ENABLE_DOCS             AUTO ON  "Enables building and installing documentation. Sphinx is required to build it.")
build_option(ENABLE_CODE_COVERAGE    BOOL OFF "Build with code coverage support")
build_option(ENABLE_DEBUG_RAW_POINTS BOOL OFF "Add a raw mode to the points window of the debugger")
build_option(ENABLE_FONTFORGE_EXTRAS BOOL OFF "Builds programs from the contrib directory")
build_option(ENABLE_MAINTAINER_TOOLS BOOL OFF "Build programs normally only used by FontForge maintainers and developers")
build_option(ENABLE_TILE_PATH        BOOL OFF "Enable a 'tile path' command (a variant of 'expand stroke')")
build_option(ENABLE_WRITE_PFM        BOOL OFF "Add the ability to save a PFM file without creating the associated font file")
build_option(ENABLE_SANITIZER        ENUM "none" "Enables a sanitizer. Requires support from the compiler."
                                          "none" "address" "leak" "thread" "undefined" "memory")

build_option(ENABLE_FREETYPE_DEBUGGER PATH "" "Use FreeType's internal debugger within FontForge.\
 If enabling this option, this must be set to the path of the FreeType source.\
 The version of that source must match the version that FontForge will link to.")

build_option(SPHINX_USE_VENV BOOL OFF "If building documentation and Sphinx\
 is not installed, try to install and use it from a python3 venv.")

build_option(REAL_TYPE ENUM "double" "Sets the floating point type used." "double" "float")
build_option(THEME     ENUM "tango"  "Sets the GUI theme." "tango" "2012")

build_option(FONT_FAMILIES_SERIF     STRING "default"  "Serif font family names to use in the UI separated by commas")
build_option(FONT_FAMILIES_UI        STRING "default"  "Font family names to use in the UI separated by commas (typically sans-serif)")
build_option(FONT_FAMILIES_LABEL     STRING "default"  "Font family names for labeling unicode characters (very wide unicode coverage, e.g. unifont, recommended)")
build_option(FONT_FAMILIES_MONO      STRING "default"  "Monospace font family names to use in the UI separated by commas")

if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
  list(APPEND _test_flags CFLAGS -Wall -Werror=implicit-function-declaration -Werror=int-conversion -Wno-misleading-indentation)
  if(CMAKE_GENERATOR STREQUAL "Ninja") # https://github.com/ninja-build/ninja/wiki/FAQ
    list(APPEND _test_flags BOTH -fdiagnostics-color=always)
  endif()
  set_supported_compiler_flags(FONTFORGE_DEFAULT_CFLAGS FONTFORGE_DEFAULT_CXXFLAGS ${_test_flags})
  list(APPEND FONTFORGE_EXTRA_CFLAGS -Wextra -pedantic -Wno-unused-parameter)
  add_compile_options(
    "$<$<COMPILE_LANGUAGE:C>:${FONTFORGE_DEFAULT_CFLAGS}>"
    "$<$<COMPILE_LANGUAGE:CXX>:${FONTFORGE_DEFAULT_CXXFLAGS}>"
  )
endif()

enable_sanitizer("${ENABLE_SANITIZER}")

set_font_family(serif "${FONT_FAMILIES_SERIF}")
set_font_family(ui "${FONT_FAMILIES_UI}")
set_font_family(label "${FONT_FAMILIES_LABEL}")
set_font_family(mono "${FONT_FAMILIES_MONO}")

# Required and default dependencies
# Note: When adding a dependency, ensure it has an imported target (wherever appropriate) 
find_package(Freetype 2.3.7 REQUIRED)
find_package(Gettext REQUIRED)
find_package_with_target(Intl REQUIRED)
find_package(GLIB 2.6 REQUIRED COMPONENTS gio gobject)
find_package(Iconv REQUIRED)
find_package(LibXml2 REQUIRED)
find_package(MathLib REQUIRED)
find_package(ZLIB REQUIRED)

check_include_file(pthread.h HAVE_PTHREAD_H)
if(HAVE_PTHREAD_H)
  find_package(Threads)
endif()

# Requirements for options
if(ENABLE_GUI)
  if(ENABLE_X11)
    if(APPLE)
      message(FATAL_ERROR "Using the X11 backend on MacOS is no longer supported.")
    endif()
    find_package(Cairo 1.6 REQUIRED)
    find_package(Pango 1.10 COMPONENTS pangocairo pangoxft REQUIRED)
    find_package(X11 REQUIRED)
  else()
    find_package(GDK3 3.10 REQUIRED)
  endif()
endif()

if(ENABLE_FREETYPE_DEBUGGER)
  if(NOT HAVE_PTHREAD_H)
    message(FATAL_ERROR "pthreads must be present to enable the FreeType debugger")
  else()
    set(FreeTypeSource_HINT ${ENABLE_FREETYPE_DEBUGGER})
    find_package(FreeTypeSource "${FREETYPE_VERSION_STRING}" EXACT REQUIRED)
  endif()
endif()

set(Python3_FIND_REGISTRY LAST)
if(BUILD_SHARED_LIBS)
  set(Python3_USE_STATIC_LIBS FALSE)
endif()
find_package_auto(ENABLE_PYTHON_SCRIPTING Python3 3.6 COMPONENTS Development Interpreter)
find_package_auto(ENABLE_DOCS             Sphinx) # Should come after ENABLE_PYTHON_SCRIPTING
find_package_auto(ENABLE_LIBSPIRO         Libspiro)
find_package_auto(ENABLE_LIBGIF           GIF)
find_package_auto(ENABLE_LIBJPEG          JPEG)
find_package_auto(ENABLE_LIBPNG           PNG)
find_package_auto(ENABLE_LIBREADLINE      Readline)
find_package_auto(ENABLE_LIBTIFF          TIFF)
find_package_auto(ENABLE_WOFF2            WOFF2)
find_package_auto(ENABLE_CODE_COVERAGE    Gcov)

add_subdirectory(inc)
add_subdirectory(Unicode)
add_subdirectory(gutils)
add_subdirectory(fontforge)
if(ENABLE_GUI)
  add_subdirectory(gdraw)
endif()
add_subdirectory(fontforgeexe)
if(ENABLE_PYTHON_EXTENSION)
  if(ENABLE_PYTHON_SCRIPTING_RESULT AND BUILD_SHARED_LIBS)
    set(ENABLE_PYTHON_EXTENSION_RESULT ON)
  elseif(NOT "${ENABLE_PYTHON_EXTENSION}" STREQUAL "AUTO")
    message(FATAL_ERROR "ENABLE_PYTHON_EXTENSION cannot be enabled if either ENABLE_PYTHON_SCRIPTING or BUILD_SHARED_LIBS is not")
  else()
    set(ENABLE_PYTHON_EXTENSION_RESULT OFF)
  endif()

  if(ENABLE_PYTHON_EXTENSION_RESULT)
    add_subdirectory(pyhook)
  endif()
endif()
add_subdirectory(contrib)
if(ENABLE_PYTHON_SCRIPTING_RESULT)
  add_subdirectory(pycontrib)
endif()
if(BUILD_TESTING)
  add_subdirectory(tests)
endif()
add_subdirectory(desktop)
if(ENABLE_DOCS AND Sphinx_FOUND)
  add_subdirectory(doc)
endif()
add_subdirectory(po)
add_subdirectory(share)
if(APPLE)
  add_subdirectory(osx)
endif()

setup_cpack()
print_build_options()

=== tests/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# Note that you should invoke the `check` target instead of
# the `test` target so that test-specific prerequisites are checked.

include(TestUtils)

if(NOT ENABLE_NATIVE_SCRIPTING AND NOT ENABLE_PYTHON_SCRIPTING_RESULT)
  return()
endif()

add_executable(systestdriver systestdriver.c)
target_link_libraries(systestdriver PRIVATE GLIB::GLIB)
if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang")
  target_compile_options(systestdriver PRIVATE -Wall -pedantic)
endif()

# Downloaded files
add_download_target("NotoSans-Regular.ttc" "https://github.com/fontforge/debugfonts/raw/master/NotoSans-Regular.ttc")
add_download_target("MunhwaGothic-Bold" "https://github.com/fontforge/debugfonts/raw/master/MunhwaGothic-Bold")

add_custom_target(test_dependencies
  DEPENDS
  "${CMAKE_CURRENT_BINARY_DIR}/fonts/NotoSans-Regular.ttc"
  "${CMAKE_CURRENT_BINARY_DIR}/fonts/MunhwaGothic-Bold"
)

add_custom_target(check
  COMMAND "${CMAKE_CTEST_COMMAND}" "--output-on-failure" "--force-new-ctest-process"
  DEPENDS
    test_dependencies
    fontforgeexe
    systestdriver
  VERBATIM
  USES_TERMINAL
)

if(ENABLE_PYTHON_SCRIPTING_RESULT AND ENABLE_PYTHON_EXTENSION_RESULT)
  add_dependencies(check fontforge_pyhook psMat_pyhook)
endif()

if(ENABLE_NATIVE_SCRIPTING)
  add_ff_test(test001.pe "Caliban.sfd" "Zapfino-4.0d3.dfont" "Zapfino-4.1d6.dfont" "Generate a few font files")
  add_ff_test(test002.pe "HanSans-Bold.otf"                                        "OTF CID font check")
  add_ff_test(test003.pe "MunhwaGothic-Bold"                                       "Non-OTF CID font check")
  add_ff_test(test004.pe "mingliu.ttc"                                             "Chunk of memory check")
  add_ff_test(test005.pe "VKern.sfd"                                               "Kerning information checks")
  add_ff_test(test006.pe "mingliu.ttc" "GillSans.dfont" "ItalicHand.sfd" "ItalicHand.svg" "MunhwaGothic-Bold" "Caliban.otf" "Incorrect names and count checks")
  add_ff_test(test007.pe "FormalScript.sfd" "dvng10a-crash.sfd"                    "Contextual chaining tables don't crash")
  add_ff_test(test008.pe "n019003l.pfb"                                            "Contextual chaining tables don't crash")
  add_ff_test(test009.pe "Ambrosia.sfd"                                            "Read and generate Type3 fonts")
  add_ff_test(test010.pe "GillSans.dfont"                                          "Generate some error messages")
  add_ff_test(test101.pe                                                           "Check for unexpected")
  add_ff_test(test102.pe "AHBugs.sfd"                                              "Infinite loop test on 0 length spline")
  add_ff_test(test103.pe                                                           "Copy/Paste clipboard test for crash")
  add_ff_test(test104.pe "SplineOverlapBug1.sfd"                                   "Remove overlap test #1")
  add_ff_test(test105.pe                                                           "while loop check  loop 10x")
  add_ff_test(test106.pe "OmittedCharBugs.sfd"                                     "Simple 'Bad Kerning' check")
  add_ff_test(test107.pe "Ambrosia.sfd" "AmbrosiaBold.sfd" "AmbrosiaItalic.sfd"    "Generate a font family") # also calls 'helper107.pe'
  add_ff_test(test108.pe "ItalicHand.sfd"                                          "Make GPOS  GSUB  morx without crashing")
  add_ff_test(test109.pe "OverlapBugs.sfd" "feta20.pfb"                            "Remove overlap test #2")
  add_ff_test(test110.pe "SimplifyBugs.sfd"                                        "Test simplify")
  add_ff_test(test111.pe "cmbsy10.pfb"                                             "Test merge fonts")
  add_ff_test(test112.pe "CourierNew.ttf"                                          "Test quadratic conversion")
  add_ff_test(test113.pe "CourierNew.ttf"                                          "Count contour points properly")
  add_ff_test(test114.pe "CaslonMM.sfd"                                            "Generate  save and open a .pfa file")
  add_ff_test(test115.pe "n019003l.pfb"                                            "Replace with reference")
  add_ff_test(test116.pe "merged.cff"                                              "Merged")
  add_ff_test(test117.pe "ecrm1000.pfb" "ecrm1000.tfm"                             "Merge kern")
  add_ff_test(test118.pe "NimbusLGCUni-Regular.sfd"                                "Test Unicode encodings") # also uses helper118A.pe helper118B.pe
  add_ff_test(test119.pe "DejaVuSerif.sfd"                                         "The 'i' glyph test")
  add_ff_test(test120.pe "NumberPoints.sfd"                                        "Another deja-vu point number")
  add_ff_test(test121.pe "AddExtremumTest.sfd"                                     "Don't distort the curve (by much)")
  #add_ff_test(test122.pe "Hinting.sfd"                                            "Check AutoHint works and retains hints")
  add_ff_test(test123.pe "MinionPro-Regular.otf"                                   "Produce equivalent font in CFF check")
  add_ff_test(test124.pe                                                           "Check that detach glyph works #1")
  add_ff_test(test125.pe "MinionPro-Regular.fea"                                   "Check that detach glyph works #2")
  add_ff_test(test126.pe "DataURI.sfd"                                             "Try SVG and PT3")
  add_ff_test(test127.pe "Ambrosia.sfd"                                            "Test generation of TrueType instructions")
  #add_ff_test(svg2ttf.pe "")
  add_ff_test(test128.pe                                                           "Test StrSplit overrun")
  add_ff_test(test130.pe "NotoSans-Regular.ttc"                                    "TTC loading")
  add_ff_test(test131.pe                                                           "libnameslist checks")
  if(ENABLE_WOFF2_RESULT)
    add_ff_test(test132.pe "CantarellMin.woff2"                                    "WOFF2 round tripping")
  endif()
  add_ff_test(test133.pe "test133.fea"                                             "Allowed characters in glyph class names")
  add_ff_test(test134.pe "test134.fea"                                             "Short-hand contextual multiple substitution")
  add_ff_test(test135.pe "test135.fea"                                             "GDEF glyph classes")
  add_ff_test(test136.pe "test136.fea"                                             "Re-using mark filtering set")
  add_ff_test(test137.pe "Ambrosia.sfd"                                            "file:// protocol")
  add_ff_test(test138.pe                                                           "Array sanity checking")
  add_ff_test(test139.pe "StrokeTests.sfd"                                            "ExpandStroke parameters")
endif()

if(ENABLE_PYTHON_SCRIPTING_RESULT)
  add_py_test(test0001.py "Ambrosia.sfd" "FontForge .sfd file open check")
  add_py_test(test0002.py "AGL For New Fonts.txt" "Loading duplicate name list")
  add_py_test(test0003.py "BoxesAndBounds.sfd" "Bounding box sanity tests")
  add_py_test(test0004.py "OpenType script tag tests")
  add_py_test(test0101.py "NotoSans-Regular.ttc" "FontForge .ttc file open check")
  add_py_test(test1001.py "Caliban.sfd" "Generate several font files")
  add_py_test(test1001a.py "Zapfino-4.0d3.dfont" "Point count check")
  add_py_test(test1001b.py "Zapfino-4.1d6.dfont" "Odd morx test without crashing")
  add_py_test(test1001c.py "Make new font")
  add_py_test(test1002.py "nuvo-medium-woff-demo.woff" "WOFF major minor meta check")
  add_py_test(test1003.py "StrokeTests.sfd" "Various stroke tests")
  add_py_test(test1004.py "DirectionTest.sfd" "Clockwise direction test")
  add_py_test(test1005.py "AddExtremaTest2.sfd" "Generate duplicate fonts test")
  add_py_test(test1006.py "Math table test")
  add_py_test(test1007.py "ayn+meem.init.svg" "Check for splinestroke 0 len fail")
  add_py_test(test1008.py "OverlapBugs.sfd" "PythonAPI: font glyph iteration")
  add_py_test(test1010.py "libnameslist checks")
  add_py_test(test1011.py "test1011.fea" "Feature file kerning with r2l lookup flag")
  add_py_test(test1012.py "test1012.otf" "GPOS kerning with r2l lookup flag")
  add_py_test(test1013.py "NotoSerifTibetan-Regular.ttf" "Read glyph names from unusual post table")
  add_py_test(test1014.py "PfEd layers round tripping")
  add_py_test(test1015.py "Caliban.sfd" "Reverse chaining tables")
  add_py_test(test1016.py "CMAPEncTest.sfd" "TrueType CMAP Encoding")
  #add_py_test(findoverlapbugs.py "find overlap bug")
  add_py_test(test926.py "DejaVuSerif.sfd" "Validate WOFF output")
  if(ENABLE_WOFF2_RESULT)
    add_py_test(test927.py "CantarellMin.woff2" "WOFF2 round tripping")
  endif()
  add_py_test(test928.py "DejaVuSerif.sfd" "String Conversion")
  add_py_test(test929.py "NotoSans-Regular.ttc" "Open Subfonts")
  add_py_test(test930.py "Point, contour, and Layer fidelity")
  add_py_test(test931.py "Point type conversion tests")
  add_py_test(test932.py "Round-trip point selection tests")
  add_py_test(test933.py "Test for SplineSetJoin Expand Stroke logic")
  add_py_test(test934.py "SFDBitmapParsing.sfd" "Parsing of a malformed SFD")
endif()

=== debian/changelog ===
fontforge (1:20220308~dfsg-1) unstable; urgency=medium

  [ Boyuan Yang ]
  * debian/control: Drop Rogério Brito from uploaders list. (Closes: #994659)

  [ Anthony Fok ]
  * New upstream version 20220308~dfsg
  * Add 20120731.b-{6,7,7.1,7.2} changelog entries
    from Nov 2015 to Apr 2016 that were missing partly due to the failed
    (forgotten? ignored?) switch from master to debian/sid branch
  * Add Jonas Smedegaard’s copyright file contributions (which I overlooked)
    to the 1:20201107~dfsg-2 changelog entry
  * Refresh Debian patches:
    - 0001-add-extra-cmake-install-rules.patch: Upstream now installs
      cidmaps by default (Thanks to Fredrick Brennan for the fix!)
    - 0004-hurd-PATH_MAX-and-MAXPATHLEN.patch: Finally forwarded upstream
      at https://github.com/fontforge/fontforge/pull/5046
    - 0005-hurd-rename-extended-to-avoid-conflict-with-gnumach-dev.patch:
      Resolve conflicts and rename more "extended" to "extendeddbl"
  * Replace 0005-hurd-rename-extended-to-avoid-conflict-with-gnumach-dev.patch
    with a much simpler 0005-hurd-undef-extended-temporarily.patch
    that "#undef extended" temporarily to circumvent the name collision
    issue on Hurd.  See https://github.com/fontforge/fontforge/pull/5047
  * Update fontforge-common.install and fontforge-extras.install
    - Stop installing app icon in legacy /usr/share/pixmaps location
      (see upstream commit 6b4ab5a)
    - cidmaps have been moved from /usr/share/fontforge/ to
      /usr/share/fontforge/cidmap/ (see commit f97a2cd)
  * Bump Standards-Version to 4.6.1 (no change)

 -- Anthony Fok <foka@debian.org>  Thu, 16 Jun 2022 04:08:43 -0600

fontforge (20120731.b-7.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix undefined symbols when using libpng16. (Closes: #820598)

 -- James Cowgill <jcowgill@debian.org>  Sat, 16 Apr 2016 01:05:09 +0100

=== debian/control ===
Source: fontforge
Section: fonts
Priority: optional
Maintainer: Debian Fonts Task Force <debian-fonts@lists.debian.org>
Uploaders:
 Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
 Davide Viti <zinosat@tiscali.it>,
 Hideki Yamane <henrich@debian.org>,
 Jonas Smedegaard <dr@jones.dk>,
 Vasudev Kamath <vasudev@copyninja.info>,
 Anthony Fok <foka@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-python3,
 shared-mime-info,
 libreadline-dev,
 libcairo2-dev,
 libfreetype-dev,
 libgif-dev,
 libjpeg-dev,
 libpango1.0-dev,
 libpng-dev,
 libspiro-dev,
 libtiff5-dev,
 libuninameslist-dev,
 libxml2-dev,
 libglib2.0-dev,
 ninja-build,
 python3,
 python3-dev,
 libwoff-dev,
 libgtk-3-dev,
 pkg-kde-tools
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 desktop-file-utils,
 potrace,
 python3-sphinx,
Standards-Version: 4.6.1
Homepage: https://fontforge.github.io/en-US/
Vcs-Git: https://salsa.debian.org/fonts-team/fontforge.git
Vcs-Browser: https://salsa.debian.org/fonts-team/fontforge
Rules-Requires-Root: no

Package: fontforge
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 fontforge-nox
Provides:
 fontforge-nox
Suggests:
 fontforge-doc,
 fontforge-extras,
 potrace,
 python3-fontforge,
Description: font editor
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  fontimage - produce a font thumbnail image;
  fontlint  - checks the font for certain common errors;
  sfddiff   - compare two font files.

Package: fontforge-nox
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Conflicts:
 fontforge
Description: font editor - non-X version
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  fontimage - produce a font thumbnail image;
  fontlint  - checks the font for certain common errors;
  sfddiff   - compare two font files.
 .
 This package contains a version of FontForge compiled with support for
 scripting but no GUI, and not require the graphics library.

Package: fontforge-common
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends}
Breaks:
 fontforge (<< 1:20160404~dfsg-3),
 fontforge-nox (<< 1:20160404~dfsg-3)
Recommends:
 fonts-cantarell,
 fonts-inconsolata
Description: font editor (common files)
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains common arch-independent files.

Package: libfontforge4
Section: libs
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Breaks:
 libfontforge2,
 libfontforge3,
 libgdraw5,
 libgdraw6,
Replaces:
 libfontforge2,
 libfontforge3,
 libgdraw5,
 libgdraw6,
Description: font editor - runtime library
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains the runtime library.

Package: python3-fontforge
Architecture: any
Multi-Arch: same
Depends:
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends}
Recommends: 
 fontforge-nox | fontforge,
Breaks:
 python-fontforge
Replaces:
 python-fontforge
Section: python
Description: font editor - Python bindings
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package provides the Python modules (the libraries fontforge and
 psMat) to access a FontForge program for font manipulations.

Package: fontforge-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Built-Using: ${sphinxdoc:Built-Using}
Description: documentation for fontforge
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package contains the documentation for fontforge.

Package: fontforge-extras
Architecture: any
Multi-Arch: foreign
Depends:
 fontforge-common (= ${source:Version}),
 libfontforge4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends}
Description: font editor - extra programs
 FontForge is a font editor.
 Use it to create, edit and convert fonts
 in OpenType, TrueType, UFO, CID-keyed, Multiple Master,
 and many other formats.
 .
 This package also provides these programs and utilities:
  acorn2sfd
  dewoff
  woff
  findtable
  pcl2ttf
  pfadecrypt
  rmligamarks
  showttf
  stripttc
  ttf2eps

## fontforge 20230101~dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 cmake_minimum_required(VERSION 3.5)
 
 # Update the version for each new release
-project(fontforge VERSION 20220308 LANGUAGES C CXX)
+project(fontforge VERSION 20230101 LANGUAGES C CXX)
 
 # No in source builds
 if("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
@@ -108,7 +108,11 @@
 find_package(Freetype 2.3.7 REQUIRED)
 find_package(Gettext REQUIRED)
 find_package_with_target(Intl REQUIRED)
-find_package(GLIB 2.6 REQUIRED COMPONENTS gio gobject)
+if(UNIX AND NOT APPLE)
+  find_package(GLIB 2.6 REQUIRED COMPONENTS gio gobject)
+else()
+  find_package(GLIB 2.58 REQUIRED COMPONENTS gio gobject)
+endif()
 find_package(Iconv REQUIRED)
 find_package(LibXml2 REQUIRED)
 find_package(MathLib REQUIRED)

=== contrib/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_subdirectory(cidmap)
if(ENABLE_FONTFORGE_EXTRAS)
  add_subdirectory(fonttools)
endif()

=== fontforge/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

set(FONTFORGE_NOINST_HEADERS
  asmfpst.h
  autohint.h
  autosave.h
  autotrace.h
  autowidth.h
  autowidth2.h
  bitmapchar.h
  bitmapcontrol.h
  bvedit.h
  clipnoui.h
  crctab.h
  cvexport.h
  cvimages.h
  cvundoes.h
  dumpbdf.h
  dumppfa.h
  effects.h
  encoding.h
  featurefile.h
  fontforgeui.h
  fvcomposite.h
  fvfonts.h
  fvimportbdf.h
  ikarus.h
  langfreq.h
  macbinary.h
  macenc.h
  mathconstants.h
  multidialog.h
  namelist.h
  othersubrs.h
  palmfonts.h
  parsepdf.h
  parsepfa.h
  parsettf.h
  parsettfatt.h
  parsettfbmf.h
  parsettfvar.h
  plugin.h
  psread.h
  pua.h
  savefont.h
  scstyles.h
  sfd.h
  spiro.h
  splinefill.h
  splinefit.h
  splineorder2.h
  splineoverlap.h
  splinerefigure.h
  splinesave.h
  splinesaveafm.h
  splinestroke.h
  splineutil.h
  splineutil2.h
  start.h
  svg.h
  tottf.h
  tottfaat.h
  tottfgpos.h
  tottfvar.h
  ttfspecial.h
  utanvec.h
  winfonts.h
  woff.h
  zapfnomen.h
)

set(FONTFORGE_INST_HEADERS
  autowidth.h
  autowidth2.h
  baseviews.h
  bezctx_ff.h
  bitmapcontrol.h
  delta.h
  edgelist.h
  edgelist2.h
  encoding.h
  fffreetype.h
  ffpython.h
  flaglist.h
  fontforge.h
  fontforgevw.h
  fvmetrics.h
  glif_name_hash.h
  glyphcomp.h
  groups.h
  lookups.h
  mem.h
  mm.h
  namehash.h
  nonlineartrans.h
  ofl.h
  PfEd.h
  print.h
  psfont.h
  savefont.h
  scriptfuncs.h
  scripting.h
  sd.h
  search.h
  sfd1.h
  sflayoutP.h
  splinefont.h
  stemdb.h
  ttf.h
  ttfinstrs.h
  uiinterface.h
  unicoderange.h
  views.h
)

add_library(fontforge
  ${FONTFORGE_NOINST_HEADERS}
  ${FONTFORGE_INST_HEADERS}
  activeinui.c
  asmfpst.c
  autohint.c
  autosave.c
  autotrace.c
  autowidth.c
  autowidth2.c
  bezctx_ff.c
  bitmapchar.c
  bitmapcontrol.c
  bvedit.c
  clipnoui.c
  crctab.c
  cvexport.c
  cvimages.c
  cvundoes.c
  dumpbdf.c
  dumppfa.c
  effects.c
  encoding.c
  featurefile.c
  flaglist.c
  fontviewbase.c
  freetype.c
  ftdelta.c
  fvcomposite.c
  fvfonts.c
  fvimportbdf.c
  fvmetrics.c
  glif_name_hash.c
  glyphcomp.c
  groups.c
  ikarus.c
  langfreq.c
  lookups.c
  macbinary.c
  macenc.c
  mathconstants.c
  mem.c
  mm.c
  namelist.c
  nonlineartrans.c
  noprefs.c
  nouiutil.c
  nowakowskittfinstr.c
  ofl.c
  othersubrs.c
  palmfonts.c
  parsepdf.c
  parsepfa.c
  parsettf.c
  parsettfatt.c
  parsettfbmf.c
  parsettfvar.c
  plugin.c
  print.c
  psread.c
  pua.c
  python.c
  savefont.c
  scripting.c
  scstyles.c
  search.c
  sfd.c
  sfd1.c
  sflayout.c
  spiro.c
  splinechar.c
  splinefill.c
  splinefit.c
  splinefont.c
  splineorder2.c
  splineoverlap.c
  splinerefigure.c
  splinesave.c
  splinesaveafm.c
  splinestroke.c
  splineutil.c
  splineutil2.c
  start.c
  stemdb.c
  svg.c
  tottf.c
  tottfaat.c
  tottfgpos.c
  tottfvar.c
  ttfinstrs.c
  ttfspecial.c
  ufo.c
  unicoderange.c
  utanvec.c
  winfonts.c
  woff.c
  zapfnomen.c
)

if(ENABLE_WOFF2_RESULT)
  target_sources(fontforge PRIVATE woff2.cc)
endif()

# Turn up warnings on a few source files
set_property(SOURCE splineoverlap.c APPEND PROPERTY COMPILE_OPTIONS ${FONTFORGE_EXTRA_CFLAGS})

set_property(TARGET fontforge PROPERTY VERSION 4)
if(BUILD_SHARED_LIBS)
  if(WIN32 OR CYGWIN)
    target_link_options(fontforge PRIVATE -Wl,--export-all-symbols) # FIXME
  endif()
endif()

# This is pretty bad...
target_include_directories(fontforge PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})

target_link_libraries(fontforge
  PUBLIC
    fontforge_common_headers
    Freetype::Freetype
    LibXml2::LibXml2
    GLIB::GLIB
    Intl::Intl
  PRIVATE
    MathLib::MathLib
    Iconv::Iconv
    ZLIB::ZLIB
)

if(APPLE)
  target_link_libraries(fontforge
    PRIVATE
    "-framework CoreServices"
  )
endif()

if(ENABLE_FREETYPE_DEBUGGER)
  target_link_libraries(fontforge PUBLIC FreeTypeSource::FreeTypeSource)
endif()
if(ENABLE_LIBSPIRO_RESULT)
  target_link_libraries(fontforge PUBLIC Libspiro::Libspiro)
endif()
if(ENABLE_LIBREADLINE_RESULT)
  target_link_libraries(fontforge PUBLIC Readline::Readline)
endif()
if(ENABLE_PYTHON_SCRIPTING_RESULT)
  target_link_libraries(fontforge PRIVATE Python3::Python)
endif()
if(ENABLE_WOFF2_RESULT)
  target_link_libraries(fontforge PRIVATE WOFF2::WOFF2)
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
  target_link_libraries(fontforge PRIVATE gunicode_interface gutils_interface)
else()
  target_link_libraries(fontforge PRIVATE gunicode gutils)
endif()

# No dev package -> no need to install if static
if(BUILD_SHARED_LIBS)
  if(WIN32 OR CYGWIN)
    install(TARGETS fontforge RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
  else()
    install(TARGETS fontforge RUNTIME DESTINATION ${CMAKE_INSTALL_LIBDIR} LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR})
  endif()
endif()

=== fontforgeexe/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_executable(fontforgeexe main.c)
set_target_properties(fontforgeexe PROPERTIES OUTPUT_NAME "fontforge")

if(ENABLE_GUI)
  target_sources(fontforgeexe PRIVATE
    alignment.c
    anchorsaway.c
    autowidth2dlg.c
    basedlg.c
    bdfinfo.c
    bitmapdlg.c
    bitmapview.c
    charinfo.c
    charview_private.h
    charview.c
    clipui.c
    combinations.c
    contextchain.c
    cursors.c
    cvaddpoints.c
    cvdebug.c
    cvdgloss.c
    cvexportdlg.c
    cvfreehand.c
    cvgetinfo.c
    cvgridfit.c
    cvhand.c
    cvhints.c
    cvimportdlg.c
    cvknife.c
    cvpalettes.c
    cvpointer.c
    cvruler.c
    cvruler.h
    cvshapes.c
    cvstroke.c
    cvtranstools.c
    deltaui.c
    displayfonts.c
    effectsui.c
    encodingui.c
    fontinfo.c
    fontview.c
    freetypeui.c
    fvfontsdlg.c
    fvmetricsdlg.c
    gotodlg.c
    groupsdlg.c
    histograms.c
    images.c
    justifydlg.c
    kernclass.c
    layer2layer.c
    lookupui.c
    macencui.c
    math.c
    metricsview.c
    mmdlg.c
    multidialog.c
    nonlineartransui.c
    openfontdlg.c
    pluginui.c
    prefs.c
    problems.c
    pythonui.c
    savefontdlg.c
    scriptingdlg.c
    scstylesui.c
    searchview.c
    sftextfield.c
    sftextfieldP.h
    sfundo.c
    sfundo.h
    showatt.c
    simplifydlg.c
    splashimage.c
    startui.c
    statemachine.c
    tilepath.c
    transform.c
    ttfinstrsui.c
    uiutil.c
    usermenu.c
    usermenu.h
    windowmenu.c
    wordlistparser.c
    wordlistparser.h
  )

  if(APPLE)
    target_sources(fontforgeexe PRIVATE macobjective.m)
    target_link_libraries(fontforgeexe
      PRIVATE
      "-framework Cocoa"
    )
  endif()

  if(ENABLE_FREETYPE_DEBUGGER)
    target_link_libraries(fontforgeexe PRIVATE Threads::Threads)
  endif()

  target_link_libraries(fontforgeexe PRIVATE gdraw)
else()
  target_sources(fontforgeexe PRIVATE startnoui.c)
endif()

if(WIN32)
  string(SUBSTRING ${PROJECT_VERSION} 0 4 FF_RC_YEAR)
  string(SUBSTRING ${PROJECT_VERSION} 4 2 FF_RC_MONTH)
  string(SUBSTRING ${PROJECT_VERSION} 6 2 FF_RC_DAY)
  string(REGEX REPLACE "^0+" "" FF_RC_MONTH "${FF_RC_MONTH}")
  string(REGEX REPLACE "^0+" "" FF_RC_DAY "${FF_RC_DAY}")
  configure_file(fontforge.exe.manifest.in fontforge.exe.manifest @ONLY)
  configure_file(fontforge.rc.in fontforge.rc @ONLY)
  target_sources(fontforgeexe PRIVATE "${CMAKE_CURRENT_BINARY_DIR}/fontforge.rc" "${CMAKE_CURRENT_BINARY_DIR}/fontforge.exe.manifest")
endif()

if(ENABLE_PYTHON_SCRIPTING_RESULT)
  target_link_libraries(fontforgeexe PRIVATE Python3::Python)
endif()

target_link_libraries(fontforgeexe PRIVATE fontforge Iconv::Iconv MathLib::MathLib)
install(TARGETS fontforgeexe RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

if(UNIX)
  install(CODE "
    foreach(_script fontimage.pe fontlint.pe sfddiff.pe)
      get_filename_component(_output \"\${_script}\" NAME_WE)
      file(READ \"${CMAKE_CURRENT_SOURCE_DIR}/\${_script}\" _input)
      file(WRITE \"${CMAKE_CURRENT_BINARY_DIR}/\${_output}\" \"#!\${CMAKE_INSTALL_PREFIX}/bin/fontforge -lang=ff\\n\${_input}\")
    endforeach()
  " COMPONENT nativescripts)
  install(FILES "${CMAKE_CURRENT_BINARY_DIR}/fontimage" "${CMAKE_CURRENT_BINARY_DIR}/fontlint" "${CMAKE_CURRENT_BINARY_DIR}/sfddiff"
    DESTINATION ${CMAKE_INSTALL_BINDIR}
    PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE
    COMPONENT nativescripts
  )
else()
  install(FILES fontimage.pe fontlint.pe sfddiff.pe DESTINATION ${CMAKE_INSTALL_DATADIR}/fontforge/nativescripts COMPONENT nativescripts)
endif()
install(FILES fontforge.1 sfddiff.1 fontlint.1 fontimage.1 DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

add_subdirectory(pixmaps)

=== gutils/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

add_library(gutils OBJECT
  dlist.c
  fsys.c
  gcol.c
  gimagebmpP.h
  gimage.c
  gimagereadbmp.c
  gimageread.c
  gimagereadgif.c
  gimagereadjpeg.c
  gimagereadpng.c
  gimagereadras.c
  gimagereadrgb.c
  gimagereadtiff.c
  gimagereadxbm.c
  gimagereadxpm.c
  gimagewritebmp.c
  gimagewritegimage.c
  gimagewritejpeg.c
  gimagewritepng.c
  gimagewritexbm.c
  gimagewritexpm.c
  gutils.c
  gwwintl.c
  prefs.c
)

if(BUILD_SHARED_LIBS)
  set_property(TARGET gutils PROPERTY POSITION_INDEPENDENT_CODE ON)
endif()

list(APPEND gutils_LIBRARIES Intl::Intl)
if(ENABLE_LIBGIF_RESULT)
  list(APPEND gutils_LIBRARIES GIF::GIF)
endif()
if(ENABLE_LIBJPEG_RESULT)
  list(APPEND gutils_LIBRARIES JPEG::JPEG)
endif()
if(ENABLE_LIBPNG_RESULT)
  list(APPEND gutils_LIBRARIES PNG::PNG)
endif()
if(ENABLE_LIBTIFF_RESULT)
  list(APPEND gutils_LIBRARIES TIFF::TIFF)
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.12.0")
  make_object_interface(gutils
    fontforge_common_headers
    gunicode_interface
    ${gutils_LIBRARIES}
  )
else()
  target_link_libraries(gutils
    PUBLIC
      fontforge_common_headers
      gunicode
      ${gutils_LIBRARIES}
  )
endif()

=== osx/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

configure_file(
  FontForge.app/Contents/Info.plist.in
  Info.plist
  @ONLY
)
configure_file(
  FontForge.app/Contents/Resources/English.lproj/InfoPlist.strings.in
  InfoPlist.strings
  @ONLY
)

# This probably could be done with CPack, but whatever
add_custom_target(macbundle
  "${CMAKE_COMMAND}" -E remove_directory "FontForge.app"
  COMMAND "${CMAKE_COMMAND}" -E copy_directory "${CMAKE_CURRENT_SOURCE_DIR}/FontForge.app" "FontForge.app"
  COMMAND "${CMAKE_COMMAND}" -E remove -f "FontForge.app/Contents/Info.plist.in" "FontForge.app/Contents/Resources/English.lproj/Info.plist.in"
  COMMAND "${CMAKE_COMMAND}" -E copy "${CMAKE_CURRENT_BINARY_DIR}/Info.plist" "FontForge.app/Contents/Info.plist"
  COMMAND "${CMAKE_COMMAND}" -E copy "${CMAKE_CURRENT_BINARY_DIR}/InfoPlist.strings" "FontForge.app/Contents/Resources/English.lproj/InfoPlist.strings"
  COMMAND "${CMAKE_COMMAND}" "-DCMAKE_INSTALL_PREFIX=${CMAKE_CURRENT_BINARY_DIR}/FontForge.app/Contents/Resources/opt/local" -P "${PROJECT_BINARY_DIR}/cmake_install.cmake"
  COMMAND "${PROJECT_SOURCE_DIR}/.github/workflows/scripts/ffosxbuild.sh" "${CMAKE_CURRENT_BINARY_DIR}/FontForge.app" "${FONTFORGE_GIT_VERSION}"
  WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
  VERBATIM
  USES_TERMINAL
)

=== contrib/cidmap/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

if(ENABLE_MAINTAINER_TOOLS)
  add_executable(mapcns1 src/mapcns1.c)
  add_executable(mapgb1 src/mapgb1.c)
  add_executable(mapjapan1 src/mapjapan1.c)
  add_executable(mapjapan2 src/mapjapan2.c)
  add_executable(mapkorean src/mapkorean.c)

  target_link_libraries(mapcns1 PRIVATE fontforge)
  target_link_libraries(mapgb1 PRIVATE fontforge)
  target_link_libraries(mapjapan1 PRIVATE fontforge)
  target_link_libraries(mapjapan2 PRIVATE fontforge)
  target_link_libraries(mapkorean PRIVATE fontforge)
endif()

install(
  FILES
    Adobe-CNS1-6.cidmap
    Adobe-GB1-5.cidmap
    Adobe-Japan1-5.cidmap
    Adobe-Japan1-6.cidmap
    Adobe-Japan1-7.cidmap
    Adobe-Japan2-0.cidmap
    Adobe-Korea1-2.cidmap
  DESTINATION ${CMAKE_INSTALL_DATADIR}/fontforge/cidmap
  COMPONENT cidmaps
)

=== fontforgeexe/pixmaps/CMakeLists.txt ===
# Distributed under the original FontForge BSD 3-clause license

# Set this for configuring the resources file
if(APPLE)
  set(GDRAW_GMENU_MACICONS "True")
else()
  set(GDRAW_GMENU_MACICONS "False")
endif()

add_subdirectory(${THEME})

=== debian/changelog ===
fontforge (1:20230101~dfsg-8) unstable; urgency=medium

  * Team upload
  * Drop non-free multiple master font code (See: #665334)
  * Document Apache-2.0 license in fontforge/othersubrs.c

 -- Bastian Germann <bage@debian.org>  Mon, 22 Sep 2025 20:21:04 +0200

fontforge (1:20230101~dfsg-7) unstable; urgency=medium

  * Team upload.
  * libfontforge4 needs a runtime dependency on python3-pkg-resources
    to work properly (See: #1095130)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 17 Sep 2025 14:36:17 +0200

fontforge (1:20230101~dfsg-6) unstable; urgency=medium

  * Team upload.
  * python3-fontforge needs a runtime dependency on python3-pkg-resources
    to work properly (See: #1095130)

 -- Alexandre Detiste <tchet@debian.org>  Wed, 17 Sep 2025 14:03:47 +0200

fontforge (1:20230101~dfsg-5) unstable; urgency=medium

  * Team upload.
  * Remove obsolete debian/README.source

  [ Helmut Grohne ]
  * Fix FTCBFS (Closes: #983666)

  [ Jonas Smedegaard ]
  * remove myself as uploader

 -- Alexandre Detiste <tchet@debian.org>  Thu, 04 Sep 2025 20:09:11 +0200

fontforge (1:20230101~dfsg-4) unstable; urgency=medium

  * Team upload.
  * debian/control: Add missing build-dependency python3-setuptools to provide
    distutils module. (Closes: #1080597)

 -- Boyuan Yang <byang@debian.org>  Thu, 05 Sep 2024 21:07:30 -0400

fontforge (1:20230101~dfsg-3) unstable; urgency=medium

  * debian/control: Drop build-dependency on potrace. The upstream build
    system is no longer having compile-time check on the software. Note that
    we still keep potrace in the binary Suggests: field. (Closes: #1035822)

 -- Boyuan Yang <byang@debian.org>  Sun, 30 Jun 2024 12:46:40 -0400

fontforge (1:20230101~dfsg-2) unstable; urgency=medium

  * debian/control: Bump Standards-Version to 4.7.0.
  * debian/patches/:
    + 0006-Update-po-files-from-Croudin-sources-after-fixing-pr.patch:
      Cherry-pick upstream PR #5330 to refresh po/ directory and fix
      FTBFS with gettext 0.22.5. (Closes: #1074258)

  [ David (Plasma) Paul ]
  * Fully support the nodoc build profile. (Closes: #1035892)
    - Don't build fontforge-doc in nodoc build profile.
    - Mark Build-Depend:python3-sphinx <!nodoc>.

 -- Boyuan Yang <byang@debian.org>  Wed, 26 Jun 2024 10:37:51 -0400

fontforge (1:20230101~dfsg-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * CVE-2024-25081: Spline Font command injection via crafted filenames
  * CVE-2024-25082: Spline Font command injection via crafted archives
    or compressed files
  * Closes: #1064967

 -- Adrian Bunk <bunk@debian.org>  Fri, 08 Mar 2024 01:15:58 +0200

fontforge (1:20230101~dfsg-1) unstable; urgency=medium

  * New upstream version 20230101~dfsg
    which incidentally fixes a FTFBS bug with fonts-ocr-a, see #1015092
    and https://github.com/fontforge/fontforge/issues/5070
  * Remove build-dependency on libuninameslist-dev, as upstream has switched
    from libuninameslist to internal nameslist functions since April 2021
  * Bump Standards-Version to 4.6.2 (no change)
  * Remove Debian patches that have been merged upstream.
    Special thanks to Jan Tojnar who contributed an enhanced version of
    0001-add-extra-cmake-install-rules.patch upstream;
    see https://github.com/fontforge/fontforge/pull/4941
  * Drop /usr/share/fontforge/python/simple/ from python3-fontforge.
    Jeremy Tan explained in https://github.com/fontforge/fontforge/pull/4941:
        It's a bunch of toy scripts, but they're basic/half-broken and are not
        easily discoverable, so yeah, no reason to bundle it
    I must have inadvertently reverted Jonas Smedegaard’s 2020-06-02 fix
    "stop ship python simple/* scripts: No longer installed upstream"
    in commit 4a44d9a38025f7b610292cfb1c6c3502cd315158 (Sorry!)
  * Fix Lintian build-depends-on-obsolete-package warning on libtiff5-dev
    by build-depending on libtiff-dev instead
  * Fix miscellaneous errors and warnings detected by Lintian

 -- Anthony Fok <foka@debian.org>  Wed, 18 Jan 2023 11:05:41 -0700

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,6 @@
  Daniel Kahn Gillmor <dkg@fifthhorseman.net>,
  Davide Viti <zinosat@tiscali.it>,
  Hideki Yamane <henrich@debian.org>,
- Jonas Smedegaard <dr@jones.dk>,
  Vasudev Kamath <vasudev@copyninja.info>,
  Anthony Fok <foka@debian.org>
 Build-Depends:
@@ -21,23 +20,23 @@
  libjpeg-dev,
  libpango1.0-dev,
  libpng-dev,
+ libpython3-dev,
  libspiro-dev,
- libtiff5-dev,
- libuninameslist-dev,
+ libtiff-dev,
  libxml2-dev,
  libglib2.0-dev,
  ninja-build,
- python3,
- python3-dev,
+ python3:any,
+ python3-dev:any,
+ python3-setuptools,
  libwoff-dev,
  libgtk-3-dev,
- pkg-kde-tools
+ pkg-kde-tools,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nodoc>,
  desktop-file-utils,
- potrace,
- python3-sphinx,
-Standards-Version: 4.6.1
+ python3-sphinx <!nodoc>,
+Standards-Version: 4.7.2
 Homepage: https://fontforge.github.io/en-US/
 Vcs-Git: https://salsa.debian.org/fonts-team/fontforge.git
 Vcs-Browser: https://salsa.debian.org/fonts-team/fontforge
@@ -119,6 +118,7 @@
 Architecture: any
 Multi-Arch: same
 Depends:
+ python3-pkg-resources,
  ${misc:Depends},
  ${shlibs:Depends}
 Breaks:
@@ -147,7 +147,7 @@
  ${misc:Depends},
  ${python3:Depends},
  ${shlibs:Depends}
-Recommends: 
+Recommends:
  fontforge-nox | fontforge,
 Breaks:
  python-fontforge
@@ -165,6 +165,7 @@
 
 Package: fontforge-doc
 Section: doc
+Build-Profiles: <!nodoc>
 Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends},

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
#export DH_VERBOSE=1

export CONFIG_SHELL=/bin/bash
export DEB_BUILD_MAINT_OPTIONS := hardening=+all

# For cross-friendly CC variable
-include /usr/share/dpkg/buildtools.mk

# avoid libtool files in python3-fontforge or fonts in fontforge-common
export DH_OPTIONS = -X.la -X.ttf

# build with X11 into subdir, to ensure non-X11 build is not missed
export DH_OPTIONS += -O--builddirectory=build/x

# build with ninja (not make) per upstream recommendation
export DH_OPTIONS += -O--buildsystem=cmake+ninja

DEB_CONFIGURE_EXTRA_FLAGS = \
 -DENABLE_MAINTAINER_TOOLS=ON \
 -DENABLE_WRITE_PFM=ON \
 -DENABLE_TILE_PATH=ON \
 -DENABLE_DEBUG_RAW_POINTS=ON \
 -DENABLE_FONTFORGE_EXTRAS=ON

ifneq (_fontforge-doc,$(filter nodoc,$(DEB_BUILD_OPTIONS))_$(filter fontforge-doc,$(shell dh_listpackages)))
DEB_CONFIGURE_EXTRA_FLAGS += -DENABLE_DOCS=OFF
endif

override_dh_auto_configure:
	dh_auto_configure --builddirectory=build/nox -- \
		$(DEB_CONFIGURE_EXTRA_FLAGS) -DENABLE_GUI=OFF -DENABLE_DOCS=OFF
	dh_auto_configure -- \
		$(DEB_CONFIGURE_EXTRA_FLAGS)

execute_before_dh_auto_build:
	dh_auto_build --builddirectory=build/nox

override_dh_auto_install:
	dh_auto_install --builddirectory=build/nox --destdir=debian/tmp/nox
	dh_auto_install --destdir=debian/tmp/x

override_dh_install:
	dh_install --package=fontforge-nox --sourcedir=debian/tmp/nox
	dh_install --remaining-packages --sourcedir=debian/tmp/x

override_dh_installdocs:
	dh_installdocs --all -- README.md AUTHORS

override_dh_installman:
	dh_installman --sourcedir=debian/tmp/x

override_dh_missing-indep:
	dh_missing -i --list-missing

override_dh_strip:
	dh_strip --dbgsym-migration='fontforge-dbg (<< 1:20170731~dfsg-2~)'

# track symbols using pkgkde-symbolshelper
%:
	dh $@ --with pkgkde_symbolshelper

=== debian/watch ===
# run "uscan --report" to check or "gbp import-orig --uscan" to update
version=4
opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%@PACKAGE@-$1%,dversionmangle=s/~dfsg\d*$//,repacksuffix=~dfsg" \
 https://github.com/fontforge/fontforge/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
